var editButton = document.createElement('button');
editButton.innerHTML = 'Edit level data';
Module.canvas.insertAdjacentElement('afterend', editButton);

editButton.onclick = function () {
    editButton.style.display = 'none';
    let container = document.createElement('div');
    container.innerHTML = `
<div style='display: flex; align-items: flex-start; height: 400px; overflow: hidden;'>
    <div class='line-numbers' style='padding: 10px 0px; overflow-y: auto; height: 100%;
     scrollbar-width: none; -ms-overflow-style: none; white-space: pre;
        background:rgb(44, 45, 48); color:#ddd; text-align: right; user-select: none; font-family: monospace;'></div>
    <textarea class='textarea' rows='20' cols='80' style='
        width: 100%; height: 100%; padding: 10px; margin:0; border: none; outline: none; resize: none; 
        overflow-y: auto; font-family: monospace;'></textarea>
</div>
<button>Load data</button>
`
    Module.canvas.insertAdjacentElement('afterend', container);


    const codeArea = container.querySelector('.textarea');
    const lineNumbers = container.querySelector('.line-numbers');
    const loadButton = container.querySelector('button');
    var errorLines = { };
    function updateLineNumbers() {
        const lines = codeArea.value.split('\n').length;
        lineNumbers.innerHTML = Array.from({ length: lines },
            (_, i) => {
                let error = errorLines[i + 1];
                if (error) {
                    return `<div style="background:#833;" title="${error}">  ${i + 1} </div>`;
                }
                return `<div style="">  ${i + 1} </div>`;
            }
        ).join('');
    }
    function syncScroll() {
        lineNumbers.scrollTop = codeArea.scrollTop;
    }

    codeArea.addEventListener('input', updateLineNumbers);
    codeArea.addEventListener('scroll', syncScroll);
    lineNumbers.addEventListener('scroll', syncScroll);

    loadButton.onclick = function () {
        var levelData = codeArea.value;
        FS.writeFile('data/level.txt', levelData);
        Module._RequestReload();
    }

    codeArea.value = FS.readFile('data/level.txt', { encoding: 'utf8' });

    updateLineNumbers();

    // Function to highlight lines with errors
    function highlightErrorLines(lines) {
        const codeLines = codeArea.value.split('\n');
        const highlightedCode = codeLines.map((line, index) => {
            return lines.includes(index + 1) ? `<span class="highlight">${line}</span>` : line;
        }).join('\n');
        codeArea.innerHTML = highlightedCode;
    }

    // Example usage: Highlight lines 2 and 4
    // highlightErrorLines([2, 4]);

}